#####################################################################
# Configuration for ALSA and the uncompressed audio mapping module
#####################################################################

#####################################################################
# General Talker configuration
#####################################################################
# role: Sets the process as a talker or listener. Valid values are
# talker or listener
role = talker

# stream_addr: Used on the listener and should be set to the 
# mac address of the talker.
stream_addr = E6:E0:B7:B5:7E:F8

# stream_uid: The unique stream ID. The talker and listener must
# both have this set the same.
stream_uid = 3

# dest_addr: When SRP is being used the destination address only needs to
# be set in the talker.  If SRP is not being used the destination address
# needs to be set in both side the talker and listener.
# The destination is a multicast address, not a real MAC address, so it
# does not match the talker or listener's interface MAC.  There are 
# several pools of those addresses for use by AVTP defined in 1722.
# At this time they need to be locally administered and must be in the range
# of 91:E0:F0:00:FE:00 - 91:E0:F0:00:FE:FF.
# Typically :00 for the first stream, :01 for the second, etc.
dest_addr = 91:e0:f0:00:fe:02

# max_interval_frames: The maximum number of packets that will be sent during 
# an observation interval. This is only used on the talker.
max_interval_frames = 1

# sr_class: A talker only setting. Values are either A or B. If not set an internal 
# default is used.
sr_class = A

# sr_rank: A talker only setting. If not set an internal default is used.
#sr_rank = 1

# max_transit_usec: Allows manually specifying a maximum transit time. 
# On the talker this value is added to the PTP walltime to create the AVTP Timestamp.
# On the listener this value is used to validate an expected valid timestamp range.
# Note: For the listener the map_nv_item_count value must be set large enough to 
# allow buffering at least as many AVTP packets that can be transmitted  during this 
# max transit time.
max_transit_usec = 2000

# max_transmit_deficit_usec: Allows setting the maximum packet transmit rate deficit that will
# be recovered when a talker falls behind. This is only used on a talker side. When a talker
# can not keep up with the specified transmit rate it builds up a deficit and will attempt to 
# make up for this deficit by sending more packets. There is normally some variability in the 
# transmit rate because of other demands on the system so this is expected. However, without this
# bounding value the deficit could grew too large in cases such where more streams are started 
# than the system can support and when the number of streams is reduced the remaining streams 
# will attempt to recover this deficit by sending packets at a higher rate. This can cause a problem
# at the listener side and significantly delay the recovery time before media playback will return 
# to normal. Typically this value can be set to the expected buffer size (in usec) that listeners are 
# expected to be buffering. For low latency solutions this is normally a small value. For non-live 
# media playback such as video playback the listener side buffers can often be large enough to held many
# seconds of data.
max_transmit_deficit_usec = 50000

# internal_latency: Allows mannually specifying an internal latency time. This is used
# only on the talker.
#internal_latency = 0

# max_stale: The number of microseconds beyond the presentation time that media queue items will be purged 
# because they are too old (past the presentation time). This is only used on listener end stations.
# Note: needing to purge old media queue items is often a sign of some other problem. For example: a delay at 
# stream startup before incoming packets are ready to be processed by the media sink. If this deficit 
# in processing or purging the old (stale) packets is not handled, syncing multiple listeners will be problematic.
#max_stale = 1000

# raw_tx_buffers: The number of raw socket transmit buffers. Typically 4 - 8 are good values.
# This is only used by the talker. If not set internal defaults are used.
#raw_tx_buffers = 4

# raw_rx_buffers: The number of raw socket receive buffers. Typically 50 - 100 are good values.
# This is only used by the listener. If not set internal defaults are used.
#raw_rx_buffers = 100

# report_seconds: How often to output stats. Defaults to 10 seconds. 0 turns off the stats. 
# report_seconds = 0

# Ethernet Interface Name. Only needed on some platforms when stack is built with no endpoint functionality
# ifname = eth0

# vlan_id: VLAN Identifier (1-4094). Used in "no endpoint" builds. Defaults to 2.
# vlan_id = 2

#####################################################################
# Mapping module configuration
#####################################################################
# map_lib: The name of the library file (commonly a .so file) that 
#  implements the Initialize function.  Comment out the map_lib name
#  and link in the .c file to the openavb_tl executable to embed the mapper
#  directly into the executable unit. There is no need to change anything
#  else. The Initialize function will still be dynamically linked in.
map_lib = libopenavb_map_clk_ref.so

# map_fn: The name of the initialize function in the mapper.
map_fn = openavbMapClkRefInitialize

# map_nv_item_count: The number of media queue elements to hold.
map_nv_item_count = 20

# map_nv_tx_rate: Transmit rate.
map_nv_tx_rate = 50

# map_nv_timestamp_interval: The number of events between timestamps.
map_nv_timestamp_interval = 160

# map_nv_timestamps_per_packet: The number of timestamps in each CRF packet.
map_nv_timestamps_per_packet = 6

# map_nv_pull_multiplier: The value of the pull multiplier. The base frequency is multiplied according
# to this:
# 0: Multiply base freq by 1.0
# 1: Multiply base freq by 1/1.001
# 2: Multiply base freq by 1.001
# 3: Multiply base freq by 24/25
# 4: Multiply base freq by 25/24
# 5: Multiply base freq by 1/8
map_nv_pull_multiplier = 0

# map_nv_base_frequency: The nominal base frequency of the events
map_nv_base_frequency = 48000

# map_nv_crf_type: The type of this CRF stream
# 0 : User defined
# 1 : Audio sample
# 2 : Video frame
# 3 : Video line
# 4 : Machine cycle
map_nv_crf_type = 1

#####################################################################
# Interface module configuration
#####################################################################
# intf_lib: The name of the library file (commonly a .so file) that 
#  implements the Initialize function.  Comment out the intf_lib name
#  and link in the .c file to the openavb_tl executable to embed the interface
#  directly into the executable unit. There is no need to change anything
#  else. The Initialize function will still be dynamically linked in.
# intf_fn: The name of the initialize function in the interface.
intf_lib = libopenavb_intf_clk_ref.so

# intf_fn: The name of the initialize function in the interface.
intf_fn = openavbIntfClkRefInitialize

# intf_nv_timestampNsecDelay: This number of nanoseconds are added to each
# of the timestamps generated by the reference clock. This must be longer
# than the duration of the timestamps within a single packet.
intf_nv_timestamp_usec_delay = 50000
